-- Author: Ashnal
-- Adds slipstreaming aka drafting like the later Mario Kart games
-- Youll see small gray speed lines when you're charging a slipstream boost
-- Theres a subtle woosh sound when it activates, and the gray speed lines will become normal size and more frequent
-- You need to have another racer within the maxangle of your heading, and be within the maxdistiance range to charge it
-- the closer you are to them, the faster it will charge
-- KNOWN BUG: the fast lines have some wierd angles on OpenGL rendering. No idea why.

--hud.add(function(v, p, c)
--    if p.spectator then return end
--    v.drawString(12,135, "seeka: " .. AngleFixed(p.mo.angle-(ANG1*7)*p.kartstuff[k_drift])>>FRACBITS,V_SNAPTOLEFT,"left")
--	v.drawString(12,145, "angle: " .. AngleFixed(p.mo.angle)>>FRACBITS,V_SNAPTOLEFT,"left")
--end)

local prefix = "slipstream_"
local cv_slipstream = CV_RegisterVar({
    name = prefix.."enabled",
    defaultvalue = "On",
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
})

local cv_colorized = CV_RegisterVar({
    name = prefix.."colorized",
    defaultvalue = "On",
    flags = NULL,
    PossibleValue = CV_OnOff
})

local cv_reminder = CV_RegisterVar({
    name = prefix.."reminder",
    defaultvalue = "On",
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
})

local cv_driftingallowed = CV_RegisterVar({
    name = prefix.."driftingallowed",
    defaultvalue = "On",
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
})

local cv_maxdistance = CV_RegisterVar({
    name = prefix.."maxdistance",
    defaultvalue = 2000, -- enough room to charge slowly, and dodge
    flags = CV_NETVAR,
    PossibleValue = CV_Unsigned
})

local cv_t2chargedist = CV_RegisterVar({
    name = prefix.."t2chargedist",
    defaultvalue = 1250,
    flags = CV_NETVAR,
    PossibleValue = CV_Unsigned
})

local cv_t3chargedist = CV_RegisterVar({
    name = prefix.."t3chargedist",
    defaultvalue = 100, -- danger close, woudln't be able to dodge an aimed item
    flags = CV_NETVAR,
    PossibleValue = CV_Unsigned
})

local cv_maxangle = CV_RegisterVar({
    name = prefix.."maxangle",
    defaultvalue = "14", --11 degrees
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = CV_Unsigned
})

-- This is measured in tics
local cv_chargetoboost = CV_RegisterVar({
    name = prefix.."chargetoboost",
    defaultvalue = 3*TICRATE+TICRATE/2,
    flags = CV_NETVAR,
    PossibleValue = CV_Unsigned
})

local cv_boosttime = CV_RegisterVar({
    name = prefix.."boosttime",
    defaultvalue = 2*TICRATE,
    flags = CV_NETVAR,
    PossibleValue = CV_Unsigned
})

local cv_minimumspeed = CV_RegisterVar({
    name = prefix.."minimumspeed",
    defaultvalue = 28,
    flags = CV_NETVAR,
    PossibleValue = CV_Unsigned
})

-- Boost youll get if you're a 1 kartspeed
local cv_maxspeedboostpercent = CV_RegisterVar({
    name = prefix.."maxspeedboostpercent",
    defaultvalue = "0.35",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

-- Boost youll get if you're a 9 or higher kartspeed
local cv_minspeedboostpercent = CV_RegisterVar({
    name = prefix.."minspeedboostpercent",
    defaultvalue = "0.20",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_accelboostpercent = CV_RegisterVar({
    name = prefix.."accelboostpercent",
    defaultvalue = "0.25",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_maxdraftspeedboostpercent = CV_RegisterVar({
    name = prefix.."maxdraftspeedboostpercent",
    defaultvalue = "0.15",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_mindraftspeedboostpercent = CV_RegisterVar({
    name = prefix.."mindraftspeedboostpercent",
    defaultvalue = 0,
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_boostreadout = CV_RegisterVar({
    name = prefix.."boostreadout",
    defaultvalue = "Off",
    PossibleValue = CV_OnOff
})

local cv_anglefinder = CV_RegisterVar({
    name = prefix.."anglefinder",
    defaultvalue = "Off",
    PossibleValue = CV_OnOff
})

local cv_booststack = CV_RegisterVar({
    name = prefix.."booststack",
    defaultvalue = "On",
	flags = CV_NETVAR,
    PossibleValue = CV_OnOff
})

local cv_booststacksneakers = CV_RegisterVar({
    name = prefix.."booststacksneakers",
    defaultvalue = "On",
	flags = CV_NETVAR,
    PossibleValue = CV_OnOff
})

local cv_boostchain = CV_RegisterVar({
    name = prefix.."boostchain",
    defaultvalue = "On",
	flags = CV_NETVAR,
    PossibleValue = CV_OnOff
})

local cv_boostchaindiminish = CV_RegisterVar({
    name = prefix.."boostchaindiminishingreturns",
    defaultvalue = 3,
	flags = CV_NETVAR,
    PossibleValue = {MIN = 1, MAX = 5}
})

local cv_panelnerf = CV_RegisterVar({
    name = prefix.."boostpaneloffroadnerf",
    defaultvalue = "Off",
	flags = CV_NETVAR,
    PossibleValue = CV_OnOff
})

-- When this is set to 0, it uses the vanilla values basedm on gamespeed
local cv_sneakeritemboost = CV_RegisterVar({
    name = prefix.."sneakeritemboost",
    defaultvalue = 0,
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_sneakeritemaccel = CV_RegisterVar({
    name = prefix.."sneakeritemaccel",
    defaultvalue = "8",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

-- When this is set to 0, it uses the vanilla values basedm on gamespeed
local cv_sneakerpanelboost = CV_RegisterVar({
    name = prefix.."sneakerpanelboost",
    defaultvalue = 0,
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_sneakerpanelaccel = CV_RegisterVar({
    name = prefix.."sneakerpanelaccel",
    defaultvalue = "8",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_invincibilityboost = CV_RegisterVar({
    name = prefix.."invincibilityboost",
    defaultvalue = "0.375",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_invincibilityaccel = CV_RegisterVar({
    name = prefix.."invincibilityaccel",
    defaultvalue = "3",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_growboost = CV_RegisterVar({
    name = prefix.."growboost",
    defaultvalue = "0.2",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_growaccel = CV_RegisterVar({
    name = prefix.."growaccel",
    defaultvalue = "0",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_driftboost = CV_RegisterVar({
    name = prefix.."driftboost",
    defaultvalue = "0.25",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_driftaccel = CV_RegisterVar({
    name = prefix.."driftaccel",
    defaultvalue = "4",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_hyuudoroboost = CV_RegisterVar({
    name = prefix.."hyuudoroboost",
    defaultvalue = "0.15",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local cv_hyuudoroaccel = CV_RegisterVar({
    name = prefix.."hyuudoroaccel",
    defaultvalue = "0.25",
    flags = CV_NETVAR|CV_FLOAT,
    PossibleValue = {MIN = 0, MAX = INT32_MAX}
})

local juicebox = CV_FindVar("juicebox")

--fucking local constants to make everything perform better, because srb2 does a string lookup for hardcode constants, which tanks performance
local INT32_MAX = INT32_MAX
local INT32_MIN = INT32_MIN
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local ANGLE_135 = ANGLE_135
local ANGLE_45 = ANGLE_45
local FRACBITS = FRACBITS
local SKINCOLOR_WHITE = SKINCOLOR_WHITE

--kartstuff constants
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_aizdriftstrat = k_aizdriftstrat
local k_offroad = k_offroad

local soundcooldown = 3*TICRATE
local starttime = 6*TICRATE + (3*TICRATE/4)

local angletotarget = 0
local disttotarget = 0
local seekangle = 0
local travelangle = 0
local driftangletolerance = 0
local slipstreamtarget = nil
local charge = 0
local speedboost = 0
local accelboost = 0
local tier = 0
local drifting = false

local pmo,tmo,pks,tks,mobjscale

freeslot(
"SPR_BSSS",
"MT_STACKINGVFX",
"S_STACKINGVFX1",
"S_STACKINGVFX2",
"S_STACKINGVFX3",
"S_STACKINGVFX4",
"S_STACKINGVFX5",
"MT_ANGLEFINDER",
"S_ANGLEFINDER"
)

states[S_STACKINGVFX1] = {SPR_BSSS, FF_TRANS30|0, 2, nil, 0, 0, S_STACKINGVFX2}
states[S_STACKINGVFX2] = {SPR_BSSS, FF_TRANS30|1, 2, nil, 0, 0, S_STACKINGVFX3}
states[S_STACKINGVFX3] = {SPR_BSSS, FF_TRANS30|2, 2, nil, 0, 0, S_STACKINGVFX4}
states[S_STACKINGVFX4] = {SPR_BSSS, FF_TRANS30|3, 2, nil, 0, 0, S_STACKINGVFX5}
states[S_STACKINGVFX5] = {SPR_BSSS, FF_TRANS30|4, 2, nil, 0, 0, S_STACKINGVFX1}

states[S_ANGLEFINDER] = {SPR_THOK, FF_TRANS30, 8, nil, 0, 0, S_ANGLEFINDER}

mobjinfo[MT_STACKINGVFX] = {
	spawnstate = S_STACKINGVFX1,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_DONTENCOREMAP|MF_NOBLOCKMAP,
	radius = 24*FRACUNIT,
	height = 100*FRACUNIT
}

mobjinfo[MT_ANGLEFINDER] = {
	spawnstate = S_ANGLEFINDER,
	flags = MF_NOGRAVITY|MF_DONTENCOREMAP|MF_NOBLOCKMAP,
	radius = 1*FRACUNIT,
	height = 1*FRACUNIT
}

-- prefer to input all fixed values
-- https://en.wikipedia.org/wiki/Feature_scaling
local function Rescale(value, oldmin, oldmax, newmin, newmax)
	return newmin +  FixedMul(FixedDiv( value-oldmin , oldmax-oldmin), newmax-newmin)
end

local function Clamp(value, newmin ,newmax)
	return min(newmax,max(newmin,value))
end

local newx,newy = 0
addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.player and mo.target.player.STACKINGVFX) then
		P_RemoveMobj(mo)
	else
		travelangle = mo.target.angle-(ANG1*9)*mo.target.player.kartstuff[k_drift]
		newx = mo.target.x + P_ReturnThrustX(mo.target, travelangle, FixedMul(32*FRACUNIT, mo.scale))
		newy = mo.target.y + P_ReturnThrustY(mo.target, travelangle, FixedMul(32*FRACUNIT, mo.scale))
		mo.destscale = FixedMul(mo.target.scale, Rescale(mo.target.player.stackedboosts*FRACUNIT, 2*FRACUNIT, 4*FRACUNIT,  FRACUNIT, 2*FRACUNIT))
		P_TeleportMove(mo, newx, newy, mo.target.z - (mo.height - FixedMul(mo.info.height,mo.target.scale))/2)
	end
end, MT_STACKINGVFX)

local newangleoffset = 0
addHook("MobjThinker", function(mo)
	if not mo.target or not cv_anglefinder.value then
		P_RemoveMobj(mo)
	else
		seekangle = mo.target.player.mo.angle-(ANG1*12)*mo.target.player.kartstuff[k_drift]
		
		if mo.angleoffset < 0 and mo.target.player.kartstuff[k_drift] then
			newangleoffset = mo.angleoffset - FixedAngle(cv_maxangle.value*2)
		elseif mo.angleoffset > 0 and mo.target.player.kartstuff[k_drift] then
			newangleoffset = mo.angleoffset + FixedAngle(cv_maxangle.value*2)
		else
			newangleoffset = mo.angleoffset
		end
		
		newx = mo.target.x + P_ReturnThrustX(mo.target, seekangle+newangleoffset, FixedMul(mo.distanceoffset, mo.target.scale))
		newy = mo.target.y + P_ReturnThrustY(mo.target, seekangle+newangleoffset, FixedMul(mo.distanceoffset, mo.target.scale))
		P_TeleportMove(mo, newx, newy, mo.target.z)
	end
end, MT_ANGLEFINDER)

local closeleft,closeright,closecenter
local function AngleFinder()
	if cv_anglefinder.value then
		if not displayplayers[0].anglefinder then
		
			closeleft = P_SpawnMobj(displayplayers[0].mo.x, displayplayers[0].mo.y, displayplayers[0].mo.z, MT_ANGLEFINDER)
			closecenter = P_SpawnMobj(displayplayers[0].mo.x, displayplayers[0].mo.y, displayplayers[0].mo.z, MT_ANGLEFINDER)
			closeright = P_SpawnMobj(displayplayers[0].mo.x, displayplayers[0].mo.y, displayplayers[0].mo.z, MT_ANGLEFINDER)
			closeleft.target = displayplayers[0].mo
			closecenter.target = displayplayers[0].mo
			closeright.target = displayplayers[0].mo
			closeleft.scale = FRACUNIT/4
			closecenter.scale = FRACUNIT/4
			closeright.scale = FRACUNIT/4
			closeleft.distanceoffset = 160*FRACUNIT
			closecenter.distanceoffset = 160*FRACUNIT
			closeright.distanceoffset = 160*FRACUNIT
			closeleft.angleoffset = -FixedAngle(cv_maxangle.value)
			closecenter.angleoffset = 0
			closeright.angleoffset = FixedAngle(cv_maxangle.value)
			closeleft.travel = true
			closecenter.travel = true
			closeright.travel = true
			
			displayplayers[0].anglefinder = true
		end
	else
		if displayplayers[0] then
			displayplayers[0].anglefinder = false
		end
	end
end

local function IntPercentToFixed(int)
	return FixedDiv(int*FRACUNIT, 100*FRACUNIT)
end

local function mapobjectscale()
	return (mapheaderinfo[gamemap] and mapheaderinfo[gamemap].mobj_scale or FRACUNIT)
end

local fast
local function SpawnFastLines(p, scale, color)
	fast = P_SpawnMobj(p.mo.x + (P_RandomRange(-36,36) * p.mo.scale),
	p.mo.y + (P_RandomRange(-36,36) * p.mo.scale),
	p.mo.z + (p.mo.height/2) + (P_RandomRange(-20,20) * p.mo.scale),
	MT_FASTLINE)
	fast.angle = R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy)
	fast.momx = 3*p.mo.momx/4
	fast.momy = 3*p.mo.momy/4
	fast.momz = 3*p.mo.momz/4
	fast.color = color
	fast.colorized = true
	fast.scale = FixedMul(scale,p.mo.scale)
	K_MatchGenericExtraFlags(fast, p.mo)
end

local function SlipstreamFastLines(p, tier, color)
    if p.fastlinestimer == 1 or tier == 1 then
		SpawnFastLines(p, FRACUNIT/tier, color)
        p.fastlinestimer = tier
    end
    p.fastlinestimer = max($-1, 1)
end

local angle,parts,i,verticalflip
local function FSonicRunDust(mo)
	angle = mo.angle
	verticalflip = mo.eflags & MFE_VERTICALFLIP
	if leveltime%2 then
		for i = 0,1 do
			newx = mo.x + P_ReturnThrustX(mo, angle + ((i == 0) and -1 or 1)*ANGLE_135, FixedMul(22*FRACUNIT, mo.scale))			
			newy = mo.y + P_ReturnThrustY(mo, angle + ((i == 0) and -1 or 1)*ANGLE_135, FixedMul(22*FRACUNIT, mo.scale))
			parts = P_SpawnMobj(newx, newy, (verticalflip and (mo.ceilingz+6*FRACUNIT*mapobjectscale() or -1) or mo.floorz-6*FRACUNIT*mapobjectscale()), MT_PARTICLE)
			parts.target = mo
			parts.angle = angle - ((i == 0) and -1 or 1)*ANGLE_45
			parts.scale = mo.scale
			parts.destscale = mo.scale*3
			parts.scalespeed = mo.scale/6
			parts.momx = 3*mo.momx/5
			parts.momy = 3*mo.momy/5				
			parts.fuse = 5
		end
	end
end

local maxtimer
local function BoostChain(p, timer)
	if cv_boostchain.value then 
		-- mmmm hacky
		
		if p.trickboost and ac_styleCheck(p, TS_BURST, false) then return timer end -- NO. Burst has its own chaining shenanigans
		
		if acrobatics then
			maxtimer = max(p.panelsneakertimer, max(p.itemsneakertimer, max(pks[k_sneakertimer], max(p.tricksneakerbuffer, max(pks[k_driftboost], max(p.trickboost, timer))))))
		else
			maxtimer = max(p.panelsneakertimer, max(p.itemsneakertimer, max(pks[k_sneakertimer], max(pks[k_driftboost], timer))))
		end
		
		if maxtimer > timer then timer = maxtimer end
		
		if p.panelsneakertimer then p.panelsneakertimer = max(timer, p.panelsneakertimer) end
		if p.itemsneakertimer then p.itemsneakertimer = max(timer, p.itemsneakertimer) end
		if pks[k_sneakertimer] then pks[k_sneakertimer] = max(timer, pks[k_sneakertimer]) end
		if p.tricksneakerbuffer then p.tricksneakerbuffer = max(timer, p.tricksneakerbuffer) end
		if pks[k_driftboost] then pks[k_driftboost] = max(timer, pks[k_driftboost]) end
		if p.trickboost then p.trickboost = max(timer, p.trickboost) end
	end
	return timer
end

-- Credits to Tyron for Firmsneaker originally
-- Yes I did ask him for permission wolfs :)
-- I've made a few adjustments
local returnedtimer
local function CheckNewBoosts(p)
	if not (p.mo and p.mo.valid) then return end
	
	if pks[k_floorboost] then
		p.naturalpanelsneakertimer = pks[k_sneakertimer]
		returnedtimer = BoostChain(p, pks[k_sneakertimer])
		p.panelsneakertimer = returnedtimer+1
		pks[k_sneakertimer] = returnedtimer
	end

	if ((juicebox and juicebox.value) or (p.SSlastframebutton == 0 and (p.cmd.buttons & BT_ATTACK))) and
	((p.SSlastframeitem == KITEM_SNEAKER and pks[k_itemamount] < p.SSlastframeamount) or
	(pks[k_rocketsneakertimer] < p.SSlastframerocketsneakertimer-1)) then
		p.naturalitemsneakertimer = pks[k_sneakertimer]
		returnedtimer = BoostChain(p, pks[k_sneakertimer])
		p.itemsneakertimer = returnedtimer+1
		pks[k_sneakertimer] = returnedtimer
	end
	
	if pks[k_driftboost] and pks[k_driftboost] > p.SSlastframedriftboost then
		pks[k_driftboost] = BoostChain(p, $)
	end
	
	if p.trickboost and p.trickboost > p.SSlastframetrickboost then
		p.trickboost = BoostChain(p, $)
	end
	
	-- and here is the chain offroad nerf, i dont feel like making a new branch for it
	if pks[k_offroad] and
	not (not cv_panelnerf.value and p.naturalpanelsneakertimer) and
	not ( p.naturalitemsneakertimer or pks[k_invincibilitytimer] or pks[k_hyudorotimer] ) then
		p.itemsneakertimer = 0
		p.panelsneakertimer = 0
		pks[k_sneakertimer] = 0 -- NO
	end
	
	p.SSlastframebutton = (p.cmd.buttons & BT_ATTACK) and ($+1) or 0
	p.SSlastframetrickboost = p.trickboost
	p.SSlastframedriftboost = pks[k_driftboost]
	p.SSlastframeitem = pks[k_itemtype]
	p.SSlastframeamount = pks[k_itemamount]
	p.SSlastframerocketsneakertimer = pks[k_rocketsneakertimer]
	
	p.naturalitemsneakertimer = max(0, ($ or 0)-1)
	p.naturalpanelsneakertimer = max(0, ($ or 0)-1)
	p.itemsneakertimer = max(0, ($ or 0)-1)
	p.panelsneakertimer = max(0, ($ or 0)-1)
end

--hud.add(function(v, p, c)
--    if p.spectator then return end
--    v.drawString(12,145,FixedMul(p.kartstuff[k_speedboost], 100*FRACUNIT)>>FRACBITS,V_SNAPTOLEFT,"left")
--end)

local T3_DISTANCE,T2_DISTANCE,MAX_DISTANCE,clampedkartspeed,skincolor
local function DoSlipstream(p)
    if not cv_slipstream.value then
		p.slipstreamboost = 0
		p.slipstreamspeedboost = 0
		p.draftingboost = 0
		return
	end -- Has to be turned on

	mobjscale = mapobjectscale()

    T3_DISTANCE = cv_t3chargedist.value * mobjscale
    T2_DISTANCE = cv_t2chargedist.value * mobjscale
    MAX_DISTANCE = cv_maxdistance.value * mobjscale

	if leveltime == 3*TICRATE and cv_reminder.value and not p.slipstreamreminded then 
		chatprintf(p, "\131* Don't forget you can \130draft\131 behind another player to charge a \130slipstream speed boost!", true)
		p.slipstreamreminded = true
	end

	if not (p.mo and p.mo.valid) then return end  -- must have valid player mapobject
	
	if pks[k_spinouttimer] or pks[k_wipeoutslow] then -- no slipstreaming if you've bumped or spun out
		p.slipstreamboost = 0
		p.slipstreamcharge = 0
		return
	end

	if p.slipstreamcharge == nil then
		p.slipstreamcharge = 0
		p.slipstreamboost = 0
		p.fastlinestimer = 0
		p.slipstreamsoundtimer = false
	end

	-- reset until we find a valid slipstreamtarget this frame
	slipstreamtarget = nil

	if (P_IsObjectOnGround(pmo)
	--and not p.kartstuff[k_hyudorotimer]
	and FixedDiv(p.speed, mobjscale)/FRACUNIT >= cv_minimumspeed.value -- must be moving decently on the ground
	) then
		
		for potentialtarget in players.iterate do          
			tmo = potentialtarget.mo
			
			if (tmo and tmo.valid -- must have valid player mapobject
			and tmo ~= pmo -- Can't splipstream off yourself
			and not potentialtarget.kartstuff[k_hyudorotimer] -- or ghosts
			and P_IsObjectOnGround(tmo) -- or airbourne karts
			and FixedDiv(potentialtarget.speed, mobjscale)/FRACUNIT >= cv_minimumspeed.value -- or slowpokes
			and not (not cv_driftingallowed.value and pks[k_drift])
			) then
				
				-- Calculating the angle at which we look for suitable draft targets based on drifting
				seekangle = pmo.angle-(ANG1*11)*pks[k_drift]
				angletotarget = abs(seekangle - R_PointToAngle2(pmo.x, pmo.y, tmo.x, tmo.y))
				disttotarget = P_AproxDistance(pmo.x - tmo.x, pmo.y - tmo.y)
				
				if pks[k_drift] then
					if angletotarget > FixedAngle(cv_maxangle.value*2) then continue end
					if disttotarget > 3*MAX_DISTANCE/5 then continue end -- max slipstream distance while drifting
				else 
					if angletotarget > FixedAngle(cv_maxangle.value) then continue end
					if disttotarget > MAX_DISTANCE then continue end -- max slipstream distance
				end -- Narrow angle for following to slipstream

				--  print(p.mo.skin + " " + potentialtarget.mo.skin + " angletotarget: " + angletotarget + " disttotarget: " + disttotarget + " slipstreamtarget: " + p.slipstreamtarget)

				slipstreamtarget = potentialtarget
				break

			end
		end
	end

	-- add/remove slipstream charge
	if slipstreamtarget then
		if disttotarget > T2_DISTANCE then
			charge = 1
		elseif disttotarget > T3_DISTANCE then
			charge = 2
		else
			charge = 2
		end

		p.slipstreamcharge = min($+charge, cv_chargetoboost.value)
		-- print(p.mo.skin + " " +slipstreamtarget.mo.skin + " angletotarget: " + angletotarget + " disttotarget: " + disttotarget + " charging slipstream: " + p.slipstreamcharge)

		-- also spawn mini lines if charging to teach/show player the charging area
		if p.slipstreamboost == 0 then
			SpawnFastLines(p, FRACUNIT/2, SKINCOLOR_WHITE)

			clampedkartspeed = Clamp(p.kartspeed, 1, 9)
			p.draftingboost = Rescale(clampedkartspeed*FRACUNIT, 9*FRACUNIT, FRACUNIT, cv_mindraftspeedboostpercent.value, cv_maxdraftspeedboostpercent.value)
			p.slipstreamsoundtimer = false
		else
			p.draftingboost = 0
		end
	else
		-- if p.slipstreamcharge then print(p.mo.skin + " losing  slipstream " + p.slipstreamcharge) end
		p.draftingboost = 0
		p.slipstreamcharge = max($-1, 0)
	end

	if p.slipstreamcharge >= cv_chargetoboost.value then
	
		-- print(p.mo.skin + " slipstreaming!")
		p.slipstreamboost = cv_boosttime.value

		if p.slipstreamsoundtimer == false then
			S_StartSoundAtVolume(pmo, sfx_s3k82, INT32_MAX)
			p.slipstreamsoundtimer = true
		end
		
	end

	if p.slipstreamboost then
		clampedkartspeed = Clamp(p.kartspeed, 1, 9)
		p.slipstreamspeedboost = Rescale(clampedkartspeed*FRACUNIT, 9*FRACUNIT, FRACUNIT, cv_minspeedboostpercent.value, cv_maxspeedboostpercent.value)

		if cv_colorized.value and p.skincolor then
			skincolor = p.skincolor
		else 
			skincolor = SKINCOLOR_WHITE
		end
		
		SpawnFastLines(p, FRACUNIT, skincolor)
		
--				if not p.STACKINGVFX then
--					p.STACKINGVFX = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_STACKINGVFX)
--					p.STACKINGVFX.target = p.mo
--					p.STACKINGVFX.color = skincolor
--					p.STACKINGVFX.colorized = true
--				end
		
		if P_IsObjectOnGround(pmo) then
			FSonicRunDust(pmo)
		end
	else
		p.slipstreamspeedboost = 0
	end

	-- if p.slipstreamboost then print(p.mo.skin + " slipstreamboost: " + p.slipstreamboost) end
	p.slipstreamboost = max($-1, 0)
	--p.slipstreamsoundtimer = max($-1, 0)
end

--lets just reimplement boosting lololololol
--by callmore#4947 and Ashnal#4043
hud.add(function(v, p, c)
    if p.spectator then return end
	if not cv_boostreadout.value then return end
	v.drawString(12,65, "trkt: " .. (p.trickboost or "0"),V_SNAPTOLEFT,"left")
	v.drawString(12,75, "dftt: " .. p.kartstuff[k_driftboost],V_SNAPTOLEFT,"left")
	v.drawString(12,85, "snkt: " .. p.kartstuff[k_sneakertimer],V_SNAPTOLEFT,"left")
	v.drawString(12,95, "nisnkt: " .. p.naturalitemsneakertimer,V_SNAPTOLEFT,"left")
	v.drawString(12,105, "isnkt: " .. p.itemsneakertimer,V_SNAPTOLEFT,"left")
	v.drawString(12,115, "npsnkt: " .. p.naturalpanelsneakertimer,V_SNAPTOLEFT,"left")
	v.drawString(12,125, "psnkt: " .. p.panelsneakertimer,V_SNAPTOLEFT,"left")
    v.drawString(12,135, "spd: " .. FixedMul(p.kartstuff[k_speedboost], 100*FRACUNIT)>>FRACBITS,V_SNAPTOLEFT,"left")
	v.drawString(12,145, "acc: " .. FixedMul(p.kartstuff[k_accelboost], 100*FRACUNIT)>>FRACBITS,V_SNAPTOLEFT,"left")
end)

local gamespeedsneakerstrength = { 53740+768, 32768, 17294+768}
local speedboost,accelboost,gamespeedboost,itemsneakerboost,panelsneakerboost,diminish,tempsneakerstrength
local function GetKartBoostPower(player)

	speedboost = 0
	accelboost = 0
	player.stackedboosts = 0

	if not cv_booststack.value then 
		if player.draftingboost then
			speedboost = max(pks[k_speedboost], player.draftingboost)
		end
		if player.slipstreamboost then
			speedboost = max(player.slipstreamspeedboost, pks[k_speedboost])
			accelboost = max(cv_accelboostpercent.value, pks[k_accelboost])
		end
		if gamespeed == 2 and pks[k_sneakertimer]
		and (cv_firmsneaker.value and player.FSdohardsneaker 
		or cv_hardsneaker.value) then
			speedboost = max(pks[k_speedboost], FRACUNIT/2)
		end
	else
		if pks[k_spinouttimer] and pks[k_wipeoutslow] == 1 then -- Slow down after you've been bumped
			pks[k_speedboost] = 0
			pks[k_accelboost] = 0
			return
		end

		if player.itemsneakertimer then
			if cv_sneakeritemboost.value == 0 then
				tempsneakerstrength = gamespeedsneakerstrength[gamespeed+1]
			else
				tempsneakerstrength = cv_sneakeritemboost.value
			end
			player.stackedboosts = $ + 1
			speedboost = $ + tempsneakerstrength /Clamp(player.stackedboosts, 1, diminish)
			accelboost = max($, cv_sneakeritemaccel.value)
		end

		if player.panelsneakertimer then
			if cv_sneakerpanelboost.value == 0 then
				tempsneakerstrength = gamespeedsneakerstrength[gamespeed+1]
			else
				tempsneakerstrength = cv_sneakerpanelboost.value
			end
			player.stackedboosts = $ + 1
			speedboost = $ + tempsneakerstrength /Clamp(player.stackedboosts, 1, diminish)
			accelboost = max($, cv_sneakerpanelaccel.value)
		end

		if pks[k_invincibilitytimer] then -- Invincibility
			speedboost = $ + cv_invincibilityboost.value /Clamp(player.stackedboosts, 1, diminish)
			accelboost = max($, cv_invincibilityaccel.value)
		end

		if pks[k_growshrinktimer] > 0 then -- Grow
			speedboost = max($, cv_growboost.value) -- DOesn't stack
			accelboost = max($, cv_growaccel.value)
		end

		--Eggpanic.
        if eggpanic and pks[k_eggmanexplode] then
            player.stackedboosts = $ + 1
            speedboost = $ + eggpanic.speedboost /Clamp(player.stackedboosts, 1, diminish)
            accelboost = max($, eggpanic.accelboost)
        end

		if (player.trickboost or 0) > 0
			player.stackedboosts = $ + 1
			speedboost = $ + player.trickbooststr /Clamp(player.stackedboosts, 1, diminish)
			accelboost = max($, 4*FRACUNIT) -- 800% accel increase?! 
		end

		if pks[k_driftboost] then -- Drift Boost
			player.stackedboosts = $ + 1 
			speedboost = $ + cv_driftboost.value /Clamp(player.stackedboosts, 1, diminish) -- + 25%
			accelboost = max($, cv_driftaccel.value)
		end

		if pks[k_startboost] then -- Startup Boost
			player.stackedboosts = $ + 1
			speedboost = $ + FRACUNIT/4 /Clamp(player.stackedboosts, 1, diminish) -- + 25%
			accelboost = max($, 6*FRACUNIT) -- + 300%
		end
		
		if player.draftingboost then
			speedboost = $ + player.draftingboost
		end
		
		if player.slipstreamboost then
			player.stackedboosts = $ + 1
			speedboost = $ + player.slipstreamspeedboost /Clamp(player.stackedboosts, 1, diminish)
			accelboost = max($, cv_accelboostpercent.value)
		end

		-- juicebox inspired fast hyuu
		if pks[k_hyudorotimer] then
			speedboost = $ + cv_hyuudoroboost.value /Clamp(player.stackedboosts, 1, diminish) -- + 25%
			accelboost = max($, cv_hyuudoroaccel.value) -- + 400%
		end

		if cv_boostchain.value == 3 then speedboost = min($,FRACUNIT) end --sanity check, im no fun. Add a cvar for this

		if  player.stackedboosts >= 2 then
			--SpawnFastLines(player, 5*FRACUNIT/3, player.skincolor+12)		
			if not player.STACKINGVFX then
				player.STACKINGVFX = P_SpawnMobj(pmo.x, pmo.y, pmo.z, MT_STACKINGVFX)
				player.STACKINGVFX.target = pmo
				player.STACKINGVFX.color = player.skincolor
				player.STACKINGVFX.colorized = true
			end
		else
			player.STACKINGVFX = nil
		end
	end
	
	-- value smoothing
	if (speedboost >= pks[k_speedboost]) then
		pks[k_speedboost] = speedboost
		--let vanilla code do the value smoothing, so to not reduce speed too fast
	end
	pks[k_accelboost] = max(pks[k_accelboost], accelboost)
end

-- HACKS! Hopefully allows someone to retain their turning radius while schmovin
-- reduces speed while sliptiding to reasonable levels to retain control
local sneakerboost = { 53740+768, 32768, 17294+768}
local sneakerspeed, sliptidespeed
addHook("MobjThinker", function(mo)
	if mo.player.kartstuff[k_aizdriftstrat] and not mo.player.kartstuff[k_drift] then
		sneakerspeed = FixedMul(K_GetKartSpeed(mo.player, false), FRACUNIT+sneakerboost[gamespeed+1])
		sliptidespeed = sneakerspeed*86/100-(mo.player.kartspeed<<FRACBITS) -- this comes out to right about 50 FU/T for most characters. I've observed all the vanilla char sliptiding between 49 and 51 on normal. SLiptides end up slightly slower on Hard for some reason
		-- only reduce spoeed if it is more than sliptidespeed
		-- reduce it by 1/12 per tic if it is above sliptidespeed
		mo.player.speed = min($,max(FixedMul($,FRACUNIT-FRACUNIT/3),sliptidespeed))
		--print("KartSpeed: "..K_GetKartSpeed(mo.player, false)>>FRACBITS.." sneakerspeed: "..sneakerspeed>>FRACBITS.." sliptidespeed: "..sliptidespeed>>FRACBITS.." actual speed: "..mo.player.speed>>FRACBITS)
	end
end, MT_PLAYER)

addHook("ThinkFrame", do
	AngleFinder()
	if cv_boostchain.value then
		diminish =  cv_boostchaindiminish.value
	else
		diminish = 1
	end
	
	for p in players.iterate do	
		pmo = p.mo
		pks = p.kartstuff
		CheckNewBoosts(p)
		DoSlipstream(p)
		GetKartBoostPower(p)
	end
end)

addHook("PlayerSpawn", function(p)
		p.slipstreamboost = 0
		p.slipstreamspeedboost = 0
		p.draftingboost = 0

		p.lastframedriftboost = 0 
		p.lastframetrickboost = 0
		p.SSlastframeitem = 0
		p.SSlastframetimer = 0
		p.SSlastframerocketsneakertimer = 0

		p.naturalitemsneakertimer = 0
		p.naturalpanelsneakertimer = 0
		p.itemsneakertimer = 0
		p.panelsneakertimer = 0
end)

--hostmod scoreboard
local slip_hmload = false
addHook("ThinkFrame", function()
	if HOSTMOD and not slip_hmload and leveltime ~= 0 then
		HM_Scoreboard_AddMod({disp = "Slipstream", var = prefix.."enabled"})
		HM_Scoreboard_AddMod({disp = "Boost Stacking", var = prefix.."booststack"})
		HM_Scoreboard_AddMod({disp = "Boost Chaining", var = prefix.."boostchain"})
		HM_Scoreboard_AddMod({disp = "Firm Sneaker", var = prefix.."firmsneaker"})
		HM_Scoreboard_AddMod({disp = "Hard Sneaker", var = prefix.."hardsneaker"})
		slip_hmload  = true
	end
end)